'use strict';

var Utils = { // jshint ignore:line
  DEFAULT_SIM_SETTINGS: {
    country: 'USA',
    operator: 'T-Mobile',
    operatorCode: '31020'
  },

  DEFAULT_DEVICE: {
    sdk: '19',
    codename: 'hammerhead'
  },

  saveAccount: function(data, callback) {
    BrowserStorage.set({
      account: data
    }, callback);
  },

  getAccountSettings: function(callback) {
    BrowserStorage.get(['sim', 'account'], function(items) {
      if (!items) {
        items = {};
      }

      if (!items.sims) {
        Utils.setSimSettings(Utils.DEFAULT_SIM_SETTINGS);
        items.sim = Utils.DEFAULT_SIM_SETTINGS;
      }

      callback.call(null, items);
    });
  },

  setSimSettings: function(sim, callback) {
    BrowserStorage.set({
      sim: sim
    }, callback);
  }
};

var Tooltips = {
  hideCurrentTooltip: function() {
    var curTooltip = document.querySelector('.help-msg:not(.hidden)');
    if (curTooltip) {
      curTooltip.classList.add('hidden');
    }
  },

  setup: function() {
    var helps = document.querySelectorAll('.btn-help');
    for (var i = 0, size = helps.length; i < size; i++) {
      var help = helps[i];
      help.addEventListener('click', function(e) {
        Tooltips.hideCurrentTooltip();
        this.nextElementSibling.classList.toggle('hidden');
      });
    }

    document.addEventListener('mousedown', function(e) {
      var insideTooltip = false;
      var parent = e.target;
      while (parent) {
        if (parent.classList && parent.classList.contains('help-msg')) {
          insideTooltip = true;
          break;
        }
        parent = parent.parentNode;
      }

      if (!insideTooltip) {
        Tooltips.hideCurrentTooltip();
      }
    });

    var tooltips = document.querySelectorAll('.help-msg');
    for (var i = 0, size = tooltips.length; i < size; i++) {
      tooltips[i].addEventListener('mousedown', function(e) {
        if (e.target.nodeName === 'A') {
          e.target.click();
        }
      });
    }
  }
};